/* Dongryeol Lee
 *
 * ClangIterator.C
 *
 * Defines iterateOn methods for the class
 *
 */

#include "ClangIterator.h"


/* Iterate methods */
void ClangIterator::iterateOn(Region *reg)
{   
  if(reg == 0){
    cout << "[ClangIterator:iterateOn(Region)]: WARNING: Ignoring null pointer.\n"
	 <<" This probably doesn't matter - it just means a named region was referred to "
	 <<"before it is defined"<<endl;
    return;
  } 
  reg->accept(regvisitor); 
}

void ClangIterator::iterateOn(Cond *cond)
{  
  if(cond == 0){
    cout << "[ClangIterator:iterateOn(Cond)]: WARNING: Ignoring null pointer.\n"
	 <<" This probably doesn't matter - it just means a named cond was referred to "
	 <<"before it is defined"<<endl;
    return;
  }
  cond->accept(cvisitor); 
}

void ClangIterator::iterateOn(Rule *rule)
{
  if(rule == 0){
    /* if we were passed a null pointer, then this most likely means 
     * the rule has not yet been defined in storage. Ie, an IDListRule may 
     * have a forward declaration of a rule that is defined later on. */
    cout << "[ClangIterator:iterateOn(Rule)]: WARNING: Ignoring null pointer.\n"
	 <<" This probably doesn't matter - it just means a named rule was referred to "
	 <<"before it is defined"<<endl;

    return;
  }
  rule->accept(rulevisitor);
}

void ClangIterator::iterateOn(Action *act)
{  
  if(act == 0){
    cout << "[ClangIterator:iterateOn(Action)]: WARNING: Ignoring null pointer.\n"
	 <<" This probably doesn't matter - it just means a named action was referred to "
	 <<"before it is defined"<<endl;
    return;
  } 
  act->accept(avisitor); 
}

void ClangIterator::iterateOn(Dir *dir)
{  
  if(dir == 0){
    cout << "[ClangIterator:iterateOn(Dir)]: WARNING: Ignoring null pointer.\n"
	 <<" This probably doesn't matter - it just means a named dir was referred to "
	 <<"before it is defined"<<endl;
    return;
  } 
  dir->accept(dvisitor); 
}
  
