/*
 * Dir Visitor - used to handle the two Dir (directive) types. 
 *
 * John Davin
 */


#ifndef DIR_VISITOR_H
#define DIR_VISITOR_H

#include "visitor.h"
#include "clangaction.h"
#include "coach_lang_comp.h"
#include "config.h"
#include "Player.h"
#include "ActionBinding.h"
#include "VarBindings.h"



extern Player *MY_PLAYER; // from main.C


class DirVisitor : public Dir::Visitor
{
 private: 

  /* Variable bindings */
  VarBindingSet myBindings;

  /* Source of the action advice, passed along to ActionPicker eventually */
  ActionBinding::SourceType sourceType;

 public:

  /* 
   * Construct a DirVisitor with our bindings initialized to the ones passed 
   * in. 
   */
  DirVisitor(VarBindingSet b, ActionBinding::SourceType source)
    : myBindings(b), sourceType(source)
    {}

  DirVisitor(ActionBinding::SourceType source)
    : sourceType(source)
    {}

  /*
   * A Dir Comm has a list of Actions, a UNumSet of players, and a bool 
   * telling whose side it's on.
   */
  void visit( DirComm* dir );
  
  /* 
   * For a DirNamed, we just look up the name in our dir storage. 
   */
  void visit( DirNamed* dir );



};

#endif // DIR_VISITOR_H
