/* Dongryeol Lee
 *
 * Spar.h
 *
 * Header file for Spar class
 * Basically, this class is the implementation of the SPAR dynamic position
 * Algorithm. It takes a region iterator from a region, and evalutes each
 * positions based on a heuristic function
 */

#include "RegionIterator.h"
#include "Geometry.h"
#include "visitor.h"
#include "region.h"
#include "clangutil.h"
#include <stdio.h>
#include <math.h>
#include <vector>

#ifndef SPAR
#define SPAR

using namespace rcss::clang;
using namespace std;

class Spar
{

 private: 

  /* Evaluate the current position in the iterator based on a heuristic */
  static double evaluatePosition(const VecPosition &pos, 
				 const UNum::unum_t &num);

 public:

  /* Get the best point for our teammate with the UNum num */
  static VecPosition getBestPt(RegionIterator *ri, 
			       const UNum::unum_t &num, 
			       const VarBindings &bindings);
  
};

#endif
