/*
    Coachable Agent communication encoding and decoding library
    Copyright (C) 2004, John Davin, Carnegie Mellon University

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

/*
 * Logging_SayMsgFactory.h - Defines a subclass of SayMsgFactory
 *   to return our subclassed message types. 
 *
 * Creation Date: 11/18/03
 * Author: John Davin
 *
 *
 *
 */


#ifndef LOGGING_SAY_MSG_FACTORY_H
#define LOGGING_SAY_MSG_FACTORY_H


#include "Logging_SayMsgTypes.h"


/*
 * Returns our subclasses which are defined in Logging_SayMsgTypes.h
 *
 */
class Logging_SayMsgFactory : public SayMsgFactory {

 public:
  OurPos *getOurPos(){ return new MyOurPos(); }

  BallPos *getBallPos(){ return new MyBallPos(); }

  BallVel *getBallVel(){ return new MyBallVel(); }

  WeHaveBall *getWeHaveBall(){ return new MyWeHaveBall(); }

  OppHasBall *getOppHasBall(){ return new MyOppHasBall(); }

  PassToPlayer *getPassToPlayer(){ return new MyPassToPlayer(); }

  PassToCoord *getPassToCoord(){ return new MyPassToCoord(); }

  WantPass *getWantPass(){ return new MyWantPass(); }

  OppPos *getOppPos(){ return new MyOppPos(); }

  TeammatePos *getTeammatePos(){ return new MyTeammatePos(); }


};





#endif


